<script lang="ts">
import {
  and,
  type ControlElement,
  formatIs,
  isStringControl,
  type JsonFormsRendererRegistryEntry,
  type JsonFormsSubStates,
  rankWith,
} from "@jsonforms/core";
import { rendererProps, type RendererProps, useJsonFormsControl } from "@jsonforms/vue";
import { ControlWrapper, DisabledIconFocus, useVuetifyControl } from "@jsonforms/vue-vuetify";
import every from "lodash/every";
import isArray from "lodash/isArray";
import isString from "lodash/isString";
import { defineComponent } from "vue";
import { VHover } from "vuetify/components";

const controlRenderer = defineComponent({
  /* eslint-disable vue/component-definition-name-casing */
  name: "doi-control-renderer",
  /* eslint-enable */
  components: {
    ControlWrapper,
    VHover,
  },
  directives: {
    DisabledIconFocus,
  },
  props: {
    ...rendererProps<ControlElement>(),
  },
  setup(props: RendererProps<ControlElement>) {
    const control = useVuetifyControl(
      useJsonFormsControl(props),
      value => value || undefined,
      300,
    );

    // For information, if you want to change data in control, you must use control.handleChange()
    let initialValue = control.control.value.data;
    if (control.control.value.data === undefined) {
      control.handleChange("title", "");
      initialValue = "";
    } else {
      initialValue = control.control.value.data;
    }
    const search = ref();

    const listData = ref();
    const loading = ref();
    const error = ref(null);

    const jsonforms = inject<JsonFormsSubStates>("jsonforms");

    function handle(pathTitle, valueTitle, pathID, valueID) {
      control.handleChange(pathTitle, valueTitle);
      control.handleChange(pathID, valueID);
    }

    if (initialValue !== "") {
      listData.value = [
        {
          title: initialValue,
          value: initialValue,
        },
      ];
    }

    return { ...control, loading, search, listData, jsonforms, handle, error };
  },
  computed: {
    suggestions(): string[] | undefined {
      const suggestions = this.control.uischema.options?.suggestion;

      if (suggestions === undefined || !isArray(suggestions) || !every(suggestions, isString)) {
        // check for incorrect data
        return undefined;
      }
      return suggestions;
    },
  },
  watch: {
    async control(value, oldValue) {
      if (value.data !== oldValue.data) {
        const apiUrl = `https://api.crossref.org/works/${value.data}`;
        const regex = /^(\d+)\./;
        const match = value.path.match(regex);
        const pos = match ? Number.parseInt(match[1], 10) : null;
        let pathTitle = "title";

        if (pos !== null && "doi" in this.jsonforms.core.data[pos]) {
          pathTitle = `${pos}.title`;
        } else if (pos !== null && "identifier" in this.jsonforms.core.data[pos]
          && "doi" in this.jsonforms.core.data[pos].identifier) {
          pathTitle = `${pos}.identifier.title`;
        }
        console.error(pathTitle);
        console.error(this.jsonforms.core.data[pos]);
        console.error(this.jsonforms.core.data);
        try {
          const response = await fetch(apiUrl);
          const data = await response.json();

          if (data.message && data.message.title) {
            this.handle(pathTitle, data.message.title[0]);
            this.error = null;
          } else {
            this.handle(pathTitle, "");
            this.error = "No title found for this DOI";
          }
        } catch (error) {
          this.handle(pathTitle, "");
          this.error = "No title found for this DOI";
          console.error("Error fetching title:", error);
        }
      }
    },
  },
});

export default controlRenderer;
export const entry: JsonFormsRendererRegistryEntry = {
  renderer: controlRenderer,
  tester: rankWith(100, and(isStringControl, formatIs("doi"))),
};
</script>

<template>
  <ControlWrapper
    v-bind="controlWrapper"
    :styles="styles"
    :isFocused="isFocused"
    :appliedOptions="appliedOptions"
  >
    <VHover v-slot="{ isHovering }">
      <v-text-field
        :id="`${control.id}-input`"
        :class="styles.control.input"
        :disabled="!control.enabled"
        :autofocus="appliedOptions.focus"
        :placeholder="appliedOptions.placeholder"
        :label="computedLabel"
        :hint="control.description"
        :persistent-hint="persistentHint()"
        :required="control.required"
        :error-messages="control.errors"
        :model-value="control.data"
        :maxlength="
          appliedOptions.restrict ? control.schema.maxLength : undefined
        "
        :counter="
          control.schema.maxLength !== undefined
            ? control.schema.maxLength
            : undefined
        "
        :clearable="isHovering"
        v-bind="vuetifyProps('v-text-field')"
        @update:model-value="onChange"
        @focus="handleFocus"
        @blur="handleBlur"
      />
      <p v-if="error" style="color: red;">
        <b>{{ error }}</b>
      </p>
      <a
        v-if="error === null && control.data !== '' && control.data !== undefined"
        :href="` https://doi.org/${control.data}`"
        target="_blank"
      >
        Read in article <v-icon icon="mdi-open-in-new" />
      </a>
    </VHover>
  </ControlWrapper>
</template>
